function  Multirun

write_param();
warning off;
startup;
path=cd;
numrun=29;      %nummber of run for each problem
%specify the problems to run
numprob={'smd1','smd2','smd3','smd4','smd5','smd6','smd7','smd8','smd9','smd10','smd11','smd12','bltp_1','bltp_2','bltp_3','bltp_4','bltp_5','bltp_6','bltp_7','bltp_8','bltp_9','bltp_10','bltp_11','bltp_12','bltp_13','tp_1','tp_2','tp_3','tp_4','tp_5','tp_6','tp_7','tp_8','tp_9','tp_10'}; 
% numprob={'smd4','smd9'}; %include all the problems to be run
alg={'nnbl'};   %Chooses the NNBL algorithm to run. 
folder={'Results'}; %Ouputs will be stored here.
numstrategy=length(alg);
seed=1999+(1:numrun);
params;
def = param;
for i=1:length(numprob) 
    for j=1:numstrategy
        prob_name=numprob{i};
        for k=1:numrun
            disp(strcat('Prob->',num2str(i),'alg-',num2str(j),' run-',num2str(k)));
            pth=strcat(path,'\',folder{j},'\',numprob{i},'\run-',num2str(k));
            mkdir(pth);
            cd(pth);
            param = def;
            write_param();
            Optimization_algo_nnbl(prob_name,seed(k));
            cd(path);
        end
    end
end
return


%Defines all algorithmic parameters and saves them to a file
function write_param()      

fp=fopen('params.m','w');
fprintf(fp,'%s','param.pop_size = 50;');
fprintf(fp,'%s','param.generations =10;');
fprintf(fp,'%s','param.pop_size_re = 50;');
fprintf(fp,'%s','param.generations_re =50;');
fprintf(fp,'%s','param.crossover_prob = 0.9;');
fprintf(fp,'%s','param.crossover_sbx_eta = 20;');
fprintf(fp,'%s','param.mutation_prob = 0.1;');
fprintf(fp,'%s','param.mutation_poly_eta = 30;');
fprintf(fp,'%s','param.nls_interval = 10;');
% fprintf(fp,'%s','param.max_fn_evals = 1e20;');
fprintf(fp,'%s','param.start_points=0;');
% SQP Parameters
fprintf(fp,'%s','param.max_fn_evals_ll = 250;');
fprintf(fp,'%s','param.maxiter_llsqp = 250;');
fprintf(fp,'%s','param.tolcon_llsqp = 1e-6;');
fprintf(fp,'%s','param.max_fn_evals_ul = 250;');
fprintf(fp,'%s','param.maxiter_ulsqp = 250;');
fprintf(fp,'%s','param.tolcon_ulsqp = 1e-6;');
fclose(fp);
return
