function [f,g, ll_func_eval] = smd8(x,counter,varargin)
if nargin == 0
    
    p=1;q=2;r=1;
    ux=p+r;lx=q+r;
    prob.nx = ux+lx;
    prob.nf = 2;
    prob.ng = 3;
    prob.ngl=1;
    prob.ngu=1;
    prob.nxl=lx;
    prob.nxu=ux;
    prob.range = cell(1, prob.nx);
    ind=1;
    %variable for u1
    for i = 1:p
        prob.range{ind} =  [-5,10];
        ind=ind+1;
    end
    %variable for u2
    for i=1:r
        prob.range{ind} = [-5,10];
        ind=ind+1;
    end
    %variable for l1
    for i=1:q
        prob.range{ind} =  [-5,10];
        ind=ind+1;
    end
    %variable for l2
    for i=1:r
        prob.range{ind} = [-5,10];
        ind=ind+1;
    end
    f = prob;
else
    [f,g, ll_func_eval] = smd8_true(x,counter);
end
return


function [f,g, ll_func_eval] = smd8_true(x,counter)

params;
archive=[];
 ll_func_eval=[];
 nn=[];
p=1;q=2;r=1;g=[];
xu1=x(1:p);xu2=x(p+1:p+r);xl1=x(p+r+1:p+r+q);xl2=x(p+r+q+1:end);
xu=[xu1 xu2];
xl=[xl1 xl2];

del_x_res = 1e-6;
f_tol=0;
f_tol_dif=1e-6;
xllb=[-5 -5 -5];
xlub=[10 10 10];
[f_base, g_base]=myfun_ll(xu,xl);
x_tmp = [];
if counter==1
    for i = 1:length(del_x_res)
        del_x=del_x_res(i)*ones(1,length(xl));
        x_tmp = [x_tmp; repmat(xl,length(xl),1)+diag(del_x); repmat(xl,length(xl),1)+diag(-del_x)];
    end
    tmp_ll = repmat(xllb,size(x_tmp,1),1);
    tmp_ul = repmat(xlub,size(x_tmp,1),1);
    x_tmp = max(x_tmp,tmp_ll);
    x_tmp = min(x_tmp,tmp_ul);
    x_tmp=unique(x_tmp,'rows');
    id_rem=find(ismember(x_tmp,xl,'rows'));
    x_tmp(id_rem,:)=[];
   x_ll = x_tmp;
    nn = size(x_ll,1);
    for i = 1:nn
        [f_ll(i,:), g_ll(i,:)]=myfun_ll(xu,x_ll(i,:));
    end
    
    if sum(min(g_base)<0)
        violation = 0;
    else
        feas_id = find(min(g_ll,[],2)>=0);
        infeas_id = setdiff(1:nn,feas_id);
        f_ll_check=[f_base;f_ll(feas_id,:)];
        pop_ll_check=[xl;x_ll(feas_id,:)];
        g_ll_check=[g_base;g_ll(feas_id,:)];
        difference = f_base-f_ll_check;
        idx1 = find(difference <= f_tol);
        idx2 = setdiff(1:length(feas_id),idx1);
        if isempty(idx2)
            violation=0;
        elseif sum(abs(difference))<=f_tol_dif
            violation=0;
        else
            violation = sum(abs(difference(idx2)));
        end
    end
end

g_ul=0;
if counter==1
    g=[-violation g_base g_ul];
elseif counter==2
    g=g_base;
elseif counter==3
    g=g_ul;
end

if ~isempty(nn)  
    ll_func_eval=nn;
end

term2 = 0;
for i=1:q-1
    term2 = term2 + ((xl1(i+1) - xl1(i).^2).^2 + (xl1(i) - 1).^2);
end

f_ul= 20+exp(1)-20*exp(-0.2*sqrt(1/p*sum((xu1).^2))) - exp(1/p*sum(cos(2*pi*xu1)))- term2 + sum((xu2).^2) - sum((xu2 - xl2.^3).^2);
f(1)=f_ul;
f(2)=f_base;


return

function [f, g]= myfun_ll(xu,xl)
p=1;q=2;r=1;
xu1=xu(1:p);xu2=xu(p+1:p+r);xl1=xl(1:q);xl2=xl(q+1:end);
term2 = 0;
for i=1:q-1
    term2 = term2 + ((xl1(i+1) - xl1(i).^2).^2 + (xl1(i) - 1).^2);
end
f_l= sum(abs(xu1))+ term2 + sum((xu2 - xl2.^3).^2);
f = f_l;
g=0;

return